{***************************************************************}
{* "MOSFET and resistor NAND" unit for LogicGates9 application *}
{***************************************************************}

unit nand1;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Grids, Menus, common;

type
  {*********}
  { TfNand1 }
  {*********}
  TfNand1 = class(TForm)
    stTitle, StaticText1: TStaticText;
    edGate, edMosfet: TMemo;
    Label1, Label2, Label3, Label4, Label5: TLabel;
    laM1, laM2, laM1Status, laM2Status: TLabel;
    Image1, Image2, Image3, imSwitch1, imSwitch2: TImage;
    shSwitch1H, shSwitch1V, shSwitch2H, shSwitch2V: TShape;
    shLed1, shLed2, shLed3: TShape;
    Shape1, Shape13, Shape18, Shape19, Shape2, Shape21, Shape22, Shape23, Shape26: TShape;
    Shape27, Shape3, Shape35, Shape36, Shape37, Shape39, Shape4, Shape5, shape6: TShape;
    sgTruthTable: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure imSwitch1Click(Sender: TObject);
    procedure imSwitch2Click(Sender: TObject);
  private
    rdSwitchA, rdSwitchB: TSwitch;
    rdLedA, rdLedB, rdLedOut: TLed;
    rdMosfet1, rdMosfet2: TMosfet;
  end;

var
  fNand1: TfNand1;

implementation

{$R *.lfm}

{*********}
{ TfNand1 }
{*********}

{ Application start: Initialisations }

procedure TfNand1.FormCreate(Sender: TObject);

begin
  // Apply subscripts
  laM1.Caption := StringReplace(laM1.Caption, '1', SUB_1, [rfReplaceAll]);
  laM2.Caption := StringReplace(laM2.Caption, '2', SUB_2, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '1', SUB_1, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '2', SUB_2, [rfReplaceAll]);
  // Initialize the switch records
  with rdSwitchA do begin
    shSwitchH := shSwitch1H; shSwitchV := shSwitch1V; imSwitch := imSwitch1;
    iPosOffH := shSwitch1H.Top; iPosOffV := shSwitch1V.Top;
    bStatus := False;
  end;
  with rdSwitchB do begin
    shSwitchH := shSwitch2H; shSwitchV := shSwitch2V; imSwitch := imSwitch2;
    iPosOffH := shSwitch2H.Top; iPosOffV := shSwitch2V.Top;
  end;
  // Initialize the LEDs
  rdLedA.shLed := shLed1;
  rdLedB.shLed := shLed2;
  rdLedOut.shLed := shLed3;
  // Initialize the MOSFETs
  rdMosfet1.laStatus := laM1Status; rdMosfet1.cChannel := 'N';
  rdMosfet2.laStatus := laM2Status; rdMosfet2.cChannel := 'N';
end;

{ Window show-up: Start the simulation }

procedure TfNand1.FormActivate(Sender: TObject);

begin
  Init(rdSwitchA, rdSwitchB, rdLedA, rdLedB, rdLedOut, rdMosfet1, rdMosfet2);
end;

{ Switch A or B closed/opened: Adapt the simulation }

procedure TfNand1.imSwitch1Click(Sender: TObject);

begin
  SwitchPush(rdSwitchA, rdLedA);
  GateNand1(rdSwitchA, rdSwitchB, rdMosfet1, rdMosfet2, rdLedOut);
end;

procedure TfNand1.imSwitch2Click(Sender: TObject);

begin
  SwitchPush(rdSwitchB, rdLedB);
  GateNand1(rdSwitchA, rdSwitchB, rdMosfet1, rdMosfet2, rdLedOut);
end;

end.

